#ifndef _HERMIT_ARCH_RCM2_QSPI_H_
#define _HERMIT_ARCH_RCM2_QSPI_H_

#define	QSPI_SPCR		(0xe6b10000)
#define		QSPI_SPCR_SPRIE		(1<<7)
#define		QSPI_SPCR_SPE		(1<<6)
#define		QSPI_SPCR_SPTIE		(1<<5)
#define		QSPI_SPCR_SPEIE		(1<<4)
#define		QSPI_SPCR_MSTR		(1<<3)
#define		QSPI_SPCR_WSWAP		(1<<1)
#define		QSPI_SPCR_BSWAP		(1<<0)
#define	QSPI_SSLP		(0xe6b10001)
#define		QSPI_SSLP_LOW_ACTIVE	(0x00)
#define		QSPI_SSLP_HIGH_ACTIVE	(0x01)
#define	QSPI_SPPCR		(0xe6b10002)
#define		QSPI_SPPCR_MOIFE	(1<<5)
#define		QSPI_SPPCR_MOIFV	(1<<4)
#define		QSPI_SPPCR_IO3FV	(1<<2)
#define		QSPI_SPPCR_IO2FV	(1<<1)
#define		QSPI_SPPCR_SPLP		(1<<0)
#define	QSPI_SPSR		(0xe6b10003)
#define		QSPI_SPSR_SPRFF		(1<<7)
#define		QSPI_SPSR_TEND		(1<<6)
#define		QSPI_SPSR_SPTEF		(1<<5)
#define	QSPI_SPDR		(0xe6b10004)
#define	QSPI_SPSCR		(0xe6b10008)
#define		QSPI_SPSCR_SPSC_MASK	(0x03)
#define	QSPI_SPSSR		(0xe6b10009)
#define	QSPI_SPBR		(0xe6b1000a)
#define	QSPI_SPDCR		(0xe6b1000b)
#define		QSPI_SPDCR_TXDMY	(1<<7)
#define	QSPI_SPCKD		(0xe6b1000c)
#define	QSPI_SSLND		(0xe6b1000d)
#define	QSPI_SPND		(0xe6b1000e)
#define	QSPI_SPCMD0		(0xe6b10010)
#define	QSPI_SPCMD1		(0xe6b10012)
#define	QSPI_SPCMD2		(0xe6b10014)
#define	QSPI_SPCMD3		(0xe6b10016)
#define		QSPI_SPCMD_SCKDEN	(1<<15)
#define		QSPI_SPCMD_SLNDEN	(1<<14)
#define		QSPI_SPCMD_SPNDEN	(1<<13)
#define		QSPI_SPCMD_LSBF		(1<<12)
#define		QSPI_SPCMD_SPB_MASK	(0x0f00)
#define		QSPI_SPCMD_SSLKP	(1<<7)
#define		QSPI_SPCMD_SPIMOD_MASK	(0x0060)
#define		QSPI_SPCMD_SPIMOD_SINGLE	(0x0000)
#define		QSPI_SPCMD_SPIMOD_DUAL		(0x0020)
#define		QSPI_SPCMD_SPIMOD_QUAD		(0x0040)
#define		QSPI_SPCMD_SPRW		(1<<4)
#define		QSPI_SPCMD_BRDV_MASK	(0x000c)
#define		QSPI_SPCMD_BRDV_DIV8	(0x000c)
#define		QSPI_SPCMD_BRDV_DIV4	(0x0008)
#define		QSPI_SPCMD_BRDV_DIV2	(0x0004)
#define		QSPI_SPCMD_BRDV_DIV0	(0x0000)
#define		QSPI_SPCMD_CPOL		(1<<1)
#define		QSPI_SPCMD_CPHA		(1<<0)
#define	QSPI_SPBFCR		(0xe6b10018)
#define		QSPI_SPBFCR_TXRST	(1<<7)
#define		QSPI_SPBFCR_RXRST	(1<<6)
#define		QSPI_SPBFCR_TXTRG_MASK	(0x30)
#define		QSPI_SPBFCR_TXTRG_31B	(0x00)
#define		QSPI_SPBFCR_TXTRG_0B	(0x30)
#define		QSPI_SPBFCR_RXTRG_MASK	(0x07)
#define		QSPI_SPBFCR_RXTRG_1B	(0x00)
#define		QSPI_SPBFCR_RXTRG_2B	(0x01)
#define		QSPI_SPBFCR_RXTRG_4B	(0x02)
#define		QSPI_SPBFCR_RXTRG_8B	(0x04)
#define		QSPI_SPBFCR_RXTRG_32B	(0x07)
#define	QSPI_SPBDCR		(0xe6b1001a)
#define		QSPI_SPBDCR_TXBC_MASK	(0x3f00)
#define		QSPI_SPBDCR_RXBC_MASK	(0x003f)
#define	QSPI_SPBMUL0		(0xe6b1001c)
#define	QSPI_SPBMUL1		(0xe6b10020)
#define	QSPI_SPBMUL2		(0xe6b10024)
#define	QSPI_SPBMUL3		(0xe6b10028)

#define QSPI_BUFFER_SIZE	(32u)

#endif
