/*
 * Copyright (c) 2014 Atmark Techno, Inc.  All Rights Reserved.
 *  Tetsuhisa KOSEKI <koseki@atmark-techno.com>
 */

#ifndef _HERMIT_TARGET_SPI_H_
#define _HERMIT_TARGET_SPI_H_

#include <autoconf.h>
#include <htypes.h>
#include <arch/byteorder.h>

/* SPI transfer flags */
#define SPI_XFER_BEGIN		(0x01)
#define SPI_XFER_END		(0x02)

extern int spi_xfer_quad(unsigned int cmd_len, const void *cmd,
		   unsigned int data_len, const void *data_out,
		   void *data_in, u32 flags);

extern int spi_xfer_normal(unsigned int data_len, const void *data_out,
		   void *data_in, unsigned long flags);

extern int spi_initialize(void);

extern void spi_start_timer(u32 usecs);
extern void spi_stop_timer(void);
extern int spi_check_timer(void);

#endif /* _HERMIT_TARGET_SPI_H_ */
